	include "doorsos.h"	;libraries to be included in program
	include "graphlib.h"

	xdef	_ti89		;what calc. to be compiled for
	xdef    _main		;where program execution starts

_main:
	jsr	graphlib::clr_scr	;library call, clears screen
	move.w	#9,d6
	bsr	spritel			;goes to sub-routine "spritel"
	
main1:
	clr.w	d0			;clears d0 register
	clr.l	d5			;clears d5 register
	move.w	d6,d5			;moves decimal 9 into d5 register
	
keyloop:	
	tst.w	(doorsos::kb_vars+$1C)	;tests to see if key was pressed
	beq	keyloop			;if it wasn't goto "keyloop"
	move.w	(doorsos::MaxHandles+$1E),d0	;moves number of key pressed into d0 register
	clr.l	(doorsos::kb_vars+$1C)		;clears key flag
	cmp	#340,d0				;compares decimal 340 with number in d0 register
	beq	right				;if equal goto "right"
	cmp	#337,d0
	beq	left
	cmp	#338,d0
	beq	up
	cmp	#344,d0
	beq	down
	cmp	#43,d0
	beq	far
	cmp	#45,d0
	beq	short
	cmp	#264,d0
	beq	leave
	bra	main1				;goto main1 (means BRanch Always)

far:
	add.w	#1,d6				;adds 1 to d6 and stores it in d6
	bra	main1				;goes to main1

short:
	cmp.w	#0,d6				;compares 0 with number in d6
	beq	main1				;if equal goes to main1 (this makes sure the distance between moves doesn't become negative)
	sub.w	#1,d6				;subtracts 1 from d6 and stores it in d6
	bra	main1				;goes to main1

spritel:
	lea    sprite,a0			;loads sprite (it's defined at bottom of code) into a0
	move.w row,d0				;moves row into d0
	move.w column,d1			;moves column into d1
	jsr graphlib::put_sprite		;uses library call to place "sprite" at d0,d1
	rts					;ReTurn from Subroutine

gone:
	move.w	#8,d2				;moves 8 into d2
	move.w	#8,d3
	move.w	#1,d4
	move.w row,d0
	move.w column,d1
	jsr graphlib::fill			;uses library call to put a blank box at d0,d1 (to clear sprite)
	rts					;ReTurn from Subroutine

leave:
	rts					;ReTurn from Subroutine (since it isn't in a subroutine it exits program)

right:
	bsr	gone				;branches to subroutine "gone"
	add.w	#1,column			;adds 1 to column and stores it in column
	bsr	spritel				;branches to subroutine "spritel"
	dbra.w	d5,right			;uses dbra (which decreases register by 1 until it hits -1 where it skips command, if register isn't -1, goes to label specified)
	bra	main1				;goes to "main1"

left:						;see above
	bsr	gone				;see above
	sub.w	#1,column			;see above
	bsr	spritel				;see above
	dbra.w	d5,left				;see above
	bra	main1				;see above

down:						;see above
	bsr	gone				;see above
	add.w	#1,row				;see above
	bsr	spritel				;see above
	dbra.w	d5,down				;see above
	bra	main1				;see above

up:						;see above
	bsr	gone				;see above
	sub.w	#1,row				;see above
	bsr	spritel				;see above
	dbra.w	d5,up				;see above
	bra	main1				;see above

;;;;;;;;VARIABLE DECLARATION SECTION;;;;;;;

row	dc.w	0		;0 is stored in "row"
column	dc.w	0

sprite:				;this is the sprite
 dc.w 8				;height
 dc.w 1				;width in bytes(one byte is 8 bits, or 8 pixels)
 dc.b %00111100			;actual sprite, 1 is an on pixel, 0 is an off pixel
 dc.b %01000010
 dc.b %10100101
 dc.b %10000001
 dc.b %10000001
 dc.b %10100101
 dc.b %01011010
 dc.b %00111100

	end			;states the end of source code   
